define("io.ox/core/deputy/dialog",["io.ox/backbone/views/modal","io.ox/backbone/views/disposable","io.ox/backbone/mini-views","io.ox/participants/add","io.ox/core/folder/api","io.ox/contacts/util","io.ox/core/deputy/api","io.ox/core/api/user","gettext!io.ox/core","io.ox/core/yell","less!io.ox/core/deputy/style"],function(i,e,n,t,a,s,l,d,r,u){"use strict";var c=0,m=257,p=33025,f=4227332,b={sendOnBehalfOf:!1,modulePermissions:{mail:{permission:m,folderIds:[a.getDefaultFolder("mail")]},calendar:{permission:m,folderIds:[a.getDefaultFolder("calendar")]}}},v={mail:r("Inbox"),calendar:r("Calendar")},g={0:r("None"),257:r("Viewer"),33025:r("Editor"),4227332:r("Author")};function y(o){var e={sendOnBehalfOf:o.get("sendOnBehalfOf"),modulePermissions:o.get("modulePermissions")},t=new i({title:r("Deputy: %1$s",s.getFullName(o.get("userData").attributes,!1))}).build(function(){var e=new Backbone.Model({permission:o.get("modulePermissions").calendar.permission}),t=new Backbone.Model({permission:o.get("modulePermissions").mail.permission});t.on("change:permission",function(e,t){var i=o.get("modulePermissions");i.mail.permission=t,o.set("modulePermissions",i)}),e.on("change:permission",function(e,t){var i=o.get("modulePermissions");i.calendar.permission=t,o.set("modulePermissions",i)}),this.$body.append($("<div>").text(r("The deputy has the following permissions")),$('<div class="select-container">').append($('<label for="inbox-deputy-selector">').text(v.mail),new n.SelectView({id:"inbox-deputy-selector",name:"permission",model:t,list:[{value:c,label:r("None")},{value:m,label:r("Viewer (read emails)")},{value:p,label:r("Editor (create/edit emails)")},{value:f,label:r("Author (create/edit/delete emails)")}]}).render().$el),new n.CustomCheckboxView({id:"send-on-behalf-checkbox",name:"sendOnBehalfOf",label:r("Deputy can send emails on your behalf"),model:o}).render().$el,$('<div class="select-container">').append($('<label for="calendar-deputy-selector">').text(v.calendar),new n.SelectView({id:"calendar-deputy-selector",name:"permission",model:e,list:[{value:c,label:r("None")},{value:m,label:r("Viewer (view appointments)")},{value:p,label:r("Editor (create/edit appointments)")},{value:f,label:r("Author (create/edit/delete appointments)")}]}).render().$el)).addClass("deputy-permissions-dialog")});o.get("deputyId")&&t.addButton({className:"btn-default pull-left",label:r("Remove"),action:"remove"}),t.addCancelButton().addButton({className:"btn-primary",label:r("Save"),action:"save"}).on("cancel",function(){void 0!==o.get("deputyId")?o.set(e):o.collection.remove(o)}).on("save",function(){o.collection.trigger("reset"),void 0!==o.get("deputyId")?l.update(o).fail(function(){u("error",r("Could not update deputy permissions.")),o.set(e)}):l.create(o).then(function(e){o.set("deputyId",e.deputyId)},function(){u("error",r("Could not create deputy.")),o.collection.remove(o)})}).on("remove",function(){h(o)}).open()}function h(e){new i({title:r("Remove deputy %1$s",s.getFullName(e.get("userData").attributes,!1))}).build(function(){this.$body.append($("<div>").text(r("Do you want to remove %1$s from your deputy list?",s.getFullName(e.get("userData").attributes,!1))))}).addCancelButton().addButton({className:"btn-primary",label:r("Remove"),action:"remove"}).on("remove",function(){l.remove(e).then(function(){e.collection.remove(e)},function(){u("error",r("Could not remove deputy."))})}).open()}var w=e.extend({events:{"click .remove":"removeDeputy","click .edit":"showPermissions"},tagName:"ul",className:"flex deputy-list-view list-unstyled",initialize:function(e){e=e||{},this.collection=new Backbone.Collection(e.deputies),this.collection.on("add reset remove",this.render.bind(this))},render:function(){return this.$el.attr("role","list").empty(),0===this.collection.length&&this.$el.append($('<li class="flex empty-message" role="listitem">').append(r("You have currently no deputies assigned.")+"<br/>"+r("Deputies can get acces to your Inbox and Calendar."))),this.collection.each(this.renderDeputy.bind(this)),this},renderDeputy:function(e){var t=e.get("userData"),i=s.getFullName(t.attributes,!0),o=s.getInitials(t.attributes),o=t.get("image1_url")?$('<i class="user-picture" aria-hidden="true">').css("background-image","url("+s.getImage(t.attributes)+")"):$('<div class="user-picture initials" aria-hidden="true">').text(o);this.$el.append($('<li class="flex" role="listitem">').attr("data-id",t.get("id")).append($('<div class="flex-item">').append(o,$('<div class="data-container">').append($('<div class="name">').append(i),$('<div class="permissions">').text((o=e,i=_(o.get("modulePermissions")).map(function(e,t){return r("%1$s (%2$s)",v[t],g[e.permission])}),o.get("sendOnBehalfOf")&&i.unshift(r("Allowed to send emails on your behalf")),i.join(", "))))),$('<div class="flex-item">').append($('<button class="btn btn-link edit">').attr("data-cid",e.cid).text(r("Edit")),$('<button class="btn btn-link remove flex">').attr({"aria-label":r("Remove"),"data-cid":e.cid}).append($.icon("fa-trash",r("Remove"))))))},removeDeputy:function(e){e.stopPropagation();e=this.collection.get(e.currentTarget.getAttribute("data-cid"));e&&h(e)},showPermissions:function(e){e=this.collection.get(e.currentTarget.getAttribute("data-cid"));e&&y(e)}}),x=Backbone.Collection.extend({modelId:function(e){return e.user_id||e.id}});return{open:function(){new i({point:"io.ox/core/deputy/dialog",title:r("Manage deputies"),width:640}).build(function(){var o=this,n=new x;this.$body.addClass("deputy-dialog-body").busy(),l.getAll().then(function(i){var e=_(i).map(function(t){return t.modulePermissions||(t.modulePermissions={}),t.modulePermissions.mail||(t.modulePermissions.mail={permission:c,folderIds:[a.getDefaultFolder("mail")]}),t.modulePermissions.calendar||(t.modulePermissions.calendar={permission:c,folderIds:[a.getDefaultFolder("calendar")]}),d.get({id:t.userId}).then(function(e){n.add(e),t.userData=n.get(e)},function(e){console.warn("Error while getting deputy user data!",t,e),i=_(i).reject(function(e){return e.deputyId===t.deputyId})})});$.when.apply($,e).always(function(){o.$body.idle(),o.$el.removeClass("compact"),o.deputyListView=new w({deputies:i}),o.$body.append(new t({apiOptions:{users:!0},placeholder:r("Add people"),collection:n,scrollIntoView:!0,useGABOnly:!0,selection:{behavior:"single"}}).render().$el,o.deputyListView.render().$el),o.$body.find("input.add-participant").focus(),n.on("add",function(e){var t=e.get("user_id")||e.get("id");t&&t!==ox.user_id?(t=_.extend({},b,{userId:t,userData:e}),y(o.deputyListView.collection.add(t))):n.remove(e,{silent:!0})}),o.deputyListView.collection.on("remove",function(e){n.remove(e.get("userId"))})})},function(e){console.error(e),u("error",r("Could not load deputy data.")),o.close()})}).addButton({className:"btn-primary",label:r("Close"),action:"cancel"}).open()}}});